#pragma once
// MySynth.h
// MySynthNXBVSTivOC̃CNXƂłׂNXB
// AVZ{̂CMySynthMainNXɕĂ̂ŁAʏ͕ύX̕KvȂB

class CMySynth : public AudioEffectX
{
public:
	CMySynth(audioMasterCallback audioMaster);
	virtual ~CMySynth(void);

	//// AudioEffectXI[o[Ch
	// Cxg
	VstInt32 canDo(char* text);
	VstInt32 processEvents(VstEvents* events);

	// M
	void processReplacing(float** inputs, float** outputs, VstInt32 sampleFrames);
	void setSampleRate(float sampleRate);

	// vpeB֘A
	bool getEffectName(char* name);
	bool getVendorString(char* text);
	bool getProductString(char* text);
	VstInt32 getVendorVersion(void);

	// p[^֘A
	void setParameter(VstInt32 index, float value);
	float getParameter(VstInt32 index);
	void getParameterName(VstInt32 index, char* text);
	void getParameterDisplay(VstInt32 index, char* text);

	// vO֘A
	bool getProgramNameIndexed(VstInt32 category, VstInt32 index, char* text);
	void getProgramName(char* name);
	void setProgramName(char* name);
	void setProgram(VstInt32 program);
	VstInt32 getChunk(void** data, bool isPreset);
	VstInt32 setChunk (void* data, VstInt32 byteSize, bool isPreset);

private:
	CMySynthMain*	m_pSynth;			// VZ{̃NX
	VstEvent	*m_events;				// Cxgobt@
	int			m_eventMaxNum;			// obt@Ɋi[\ȍőCxg
	int			m_eventNum;				// obt@Ɋi[ĂCxg
	int			m_currentEventNo;		// ݏ̃CxgNo
	int			m_currentSample;		// ݏ̃TvNo
};

