#pragma once
// MySynthMain.h
// VZ{̃NXyсÃR|[lgƂȂNX

////////////////////////////////////////////////////////////
// VCO(IV[^[)NX
#define		WF_SINE		0	// TCg
#define		WF_TRI		1	// Opg
#define		WF_SAW		2	// g
#define		WF_SQUARE	3	// `g

class CVCO : public CSignalProcessor{
public:
	CVCO();
	virtual ~CVCO();

	// f`[lݒ
	void setDetune(float det);

	// p^lݒ
	void setWF(int wf);				// g`
	void setPortaTime(float fVal);	// |^g^C

	// Um[gԍݒ
	void setNoteNo(int nn,BOOL isKeyOn);

	// mM(CSignalProcessorp)
	void processSignal(int size, SIGREAL* pSig, BOOL* pProcessed);

private:
	// g`ɒڂϐ
	float m_nn;				// Uw肳ꂽm[gNo
	float m_curNn;			// ݔŨm[gNoim[gNoɂ鎖Ń|^g̃m[gNo\j
	float m_portaStartNn;	// |^gJnnoteNo
	float m_curPortaTime;	// |^goߎԁi1ŐKA0`1Ń|^gj
	float m_portaTimeDelta;	// |^gx
	float m_detuneCent;		// {CXԃf`[liPʂ̓Zgj
	unsigned int m_p;		// ʑ(Œ菬_)
	float m_pp;				// ʑ(_)Arp
	int m_wf;				// g`
};


////////////////////////////////////////////////////////////
// {CXNX
class CMyVoice : public IVoice{
public:
	CMyVoice();
	~CMyVoice();

	// {CXԃf`[(IVoicep)
	void setDetune(float det);

	// gK[֘A(IVoicep)
	void setNoteInfo(int nn,int velo);
	void trigger(void);
	void release(int velo);
	int  getNoteNo(void);
	BOOL isKeyOn(void);
	BOOL isBusy(void);

	// M(CSignalProcessorp)
	void processSignal(int size, SIGREAL* pSig, BOOL* pProcessed);
	void changedSamplingFreq(void);

	// OJIuWFNg
	CVCO m_vco;		// VCO

private:
	int m_nn;		// ݂̃m[gNO
	int m_velo;		// gK[̃xVeBl
	BOOL m_bKeyOn;	// L[Ă邩ǂ
};


////////////////////////////////////////////////////////////
// VZ{̃NXyсAp^\̒`

// VZ̊{萔
#define	VOICE_NUM			16		// 16{CXƂ
#define	SOUND_PARAM_NUM		5		// TEhp^̎ސ
#define	PROGRAM_NUM			128		// 128vO

// TEhp^IDꗗ
#define	SPID_MASTER_VOL			0		// }X^[{[
#define	SPID_VCO_WF				1		// VCOEF[utH[
#define	SPID_VCO_PORTA_TIME		2		// VCO|^g^C
#define	SPID_VOICE_MODE			3		// {CX[h
#define	SPID_UNISON_NUM			4		// j]{CX

// P̃pb`i[\
typedef struct tagPatchInfo{
	char programName[25];					// vO(24+I[)
	float soundParam[SOUND_PARAM_NUM];	// TEhp^ێ̈
} PATCHINFO;

// VZ{̃NX
class CMySynthMain : public CSignalProcessor, public CMIDIInDev{
public:
	CMySynthMain::CMySynthMain();
	virtual ~CMySynthMain(void);

	// MIDICxg̃nh(CMIDIInDevp)
	void receiveNoteOff(int nn,int v);
	void receiveNoteOn(int nn,int v);
	void receiveDumperPedal(BOOL b);
	void setBaseTempo(float t);

	// p^֘A
	void setSoundParam(int id,float fVal);		// TEhp^l̎M
	void getSoundParamName(int id,char* rtn);	// TEhp^̕ԐM
	void getSoundParamValText(int id,char* rtn);// TEhp^lɑΉeLXgԐM

	// vO֘A
	void setProgramNo(int no);	// vO(pb`)̕ύXv

	// M(CSignalProcessorp)
	void processSignalLR(int size, SIG_LR* pSig, BOOL* pProcessed);
	void changedSamplingFreq(void);

	// pb`iJIuWFNgj
	PATCHINFO m_pi[PROGRAM_NUM];

private:
	CKeyboardInfo m_kbdInfo;		// ՏǗNX
	CVoiceCtl m_vc;					// {CXRg[[
	CMyVoice m_voice[VOICE_NUM];	// {CX
	float m_masterVol;				// }X^[{[
	float* m_curSoundParam;			// JgTEhp^iւ̃|C^j
};

